#include <dos.h>
#include <math.h>

void draw_face (char col);
void draw_line(int start,int end,char col,unsigned int a[]);
void draw_pixel(int ind,char col);
char get_pixel(int x,int y);

typedef struct {
 long x,y,z;
} t_3d;

typedef struct {
 char ptr[3];
} t_faccia;

struct {
 int x,y;
} schermo[3];

t_3d punto[10],rot,spost,aus[10],normale;
t_faccia faccia[16];
int i,k,seno[256],coseno[256],xs,ys,xmax,xmin,ymax,ymin;
long nx,ny,nz,ang;
union REGS r;
unsigned char col,a=0;
unsigned int ind,back[256];

main()
{
 r.x.ax=0X0013;
 int86(0X10,&r,&r);

 punto[0].x=0;
 punto[0].y=32;
 punto[0].z=0;
 punto[1].x=0;
 punto[1].y=-32;
 punto[1].z=0;
 for(i=0;i<8;i++)
 {
  punto[i+2].x=cos(i*M_PI/4)*20;
  punto[i+2].y=0;
  punto[i+2].z=sin(i*M_PI/4)*20;
  faccia[i].ptr[0]=0;
  faccia[i].ptr[1]=(i+1)%8+2;
  faccia[i].ptr[2]=i+2;
  faccia[i+8].ptr[0]=1;
  faccia[i+8].ptr[1]=i+2;
  faccia[i+8].ptr[2]=(i+1)%8+2;
 }
/* punto[2].x=16;
 punto[2].y=0;
 punto[2].z=16;
 punto[3].x=16;
 punto[3].y=0;
 punto[3].z=-16;
 punto[4].x=-16;
 punto[4].y=0;
 punto[4].z=-16;
 punto[5].x=-16;
 punto[5].y=0;
 punto[5].z=16;

 faccia[0].ptr[0]=5;
 faccia[0].ptr[1]=2;
 faccia[0].ptr[2]=0;
 faccia[1].ptr[0]=2;
 faccia[1].ptr[1]=3;
 faccia[1].ptr[2]=0;
 faccia[2].ptr[0]=3;
 faccia[2].ptr[1]=4;
 faccia[2].ptr[2]=0;
 faccia[3].ptr[0]=4;
 faccia[3].ptr[1]=5;
 faccia[3].ptr[2]=0;
 faccia[4].ptr[0]=1;
 faccia[4].ptr[1]=2;
 faccia[4].ptr[2]=5;
 faccia[5].ptr[0]=1;
 faccia[5].ptr[1]=3;
 faccia[5].ptr[2]=2;
 faccia[6].ptr[0]=1;
 faccia[6].ptr[1]=4;
 faccia[6].ptr[2]=3;
 faccia[7].ptr[0]=1;
 faccia[7].ptr[1]=5;
 faccia[7].ptr[2]=4;*/

 for(i=0;i<256;i++) seno[i]=sin(i*M_PI/128)*256;
 for(i=0;i<256;i++) coseno[i]=cos(i*M_PI/128)*256;
 while(!kbhit())
 {
  a++;
  spost.x=seno[a]>>2;
  spost.y=seno[(char)((a+128)<<1)]>>3;
  spost.z=seno[(char)(a+64)]>>2;
  rot.x=a;
  rot.y=a;
  rot.z=a;
  while(!(inportb(0X03DA)&0X08));
  while(inportb(0X03DA)&0X08);
  for(ind=ymin*320+xmin;ind<=ymax*320+xmin;ind+=320)
  {
   asm {
    push es
    mov  ax,0A000h
    mov  es,ax
    mov  di,ind
    xor  ax,ax
    mov  cx,xmax
    sub  cx,xmin
    shr  cx,1
    inc  cx
    rep  stosw
    pop  es
   }
  }
  xmax=ymax=0;
  xmin=319;
  ymin=199;
  for(i=0;i<10;i++)
  {
   // rotate around the x-axis
   ny=(punto[i].y*coseno[rot.x]-punto[i].z*seno[rot.x]);
   nz=(punto[i].y*seno[rot.x]+punto[i].z*coseno[rot.x]);
   nx=(punto[i].x)<<8;
   aus[i].x=nx;
   aus[i].y=ny;
   aus[i].z=nz;

   // rotate around the y-axis
   nx=(aus[i].x * coseno[rot.y]-aus[i].z * seno[rot.y]);
   nz=(aus[i].x * seno[rot.y]+aus[i].z * coseno[rot.y]);
   aus[i].x=nx;
   aus[i].y=aus[i].y<<8;
   aus[i].z=nz;

   // rotate around the z-axis
   nx=(aus[i].x * coseno[rot.z]-aus[i].y * seno[rot.z]);
   ny=(aus[i].x * seno[rot.z]+aus[i].y * coseno[rot.z]);
   aus[i].x=nx>>16;
   aus[i].y=ny>>16;
   aus[i].z=aus[i].z>>8;


   aus[i].z+=spost.z<<8;
   aus[i].x+=spost.x<<8;
   aus[i].y+=spost.y<<8;
   aus[i].z-=0XFF00;
  }
  for(k=0;k<16;k++)
  {
   normale.x=((aus[faccia[k].ptr[0]].y-aus[faccia[k].ptr[1]].y)*(aus[faccia[k].ptr[0]].z-aus[faccia[k].ptr[2]].z) - (aus[faccia[k].ptr[0]].z-aus[faccia[k].ptr[1]].z)*(aus[faccia[k].ptr[0]].y-aus[faccia[k].ptr[2]].y))>>16;
   normale.y=((aus[faccia[k].ptr[0]].z-aus[faccia[k].ptr[1]].z)*(aus[faccia[k].ptr[0]].x-aus[faccia[k].ptr[2]].x) - (aus[faccia[k].ptr[0]].x-aus[faccia[k].ptr[1]].x)*(aus[faccia[k].ptr[0]].z-aus[faccia[k].ptr[2]].z))>>16;
   normale.z=((aus[faccia[k].ptr[0]].x-aus[faccia[k].ptr[1]].x)*(aus[faccia[k].ptr[0]].y-aus[faccia[k].ptr[2]].y) - (aus[faccia[k].ptr[0]].y-aus[faccia[k].ptr[1]].y)*(aus[faccia[k].ptr[0]].x-aus[faccia[k].ptr[2]].x))>>16;
   ang=normale.x*aus[faccia[k].ptr[0]].x+normale.y*aus[faccia[k].ptr[0]].y+normale.z*aus[faccia[k].ptr[0]].z;
   if(ang<0)
   {
    for(i=0;i<3;i++)
    {
     schermo[i].x=(aus[faccia[k].ptr[i]].x)/(-(aus[faccia[k].ptr[i]].z)>>8)+160;
     schermo[i].y=100-(aus[faccia[k].ptr[i]].y)/(-(aus[faccia[k].ptr[i]].z)>>8);
     if(schermo[i].x>xmax) xmax=schermo[i].x;
     if(schermo[i].x<xmin) xmin=schermo[i].x;
     if(schermo[i].y>ymax) ymax=schermo[i].y;
     if(schermo[i].y<ymin) ymin=schermo[i].y;
    }
    draw_face(((-normale.x+normale.y+normale.z)>>7)+24);
   }
  }
 }
}


void draw_face (char col)
{
 int i,aus,a1,b1;
 unsigned int a[100],b[100];

 if(schermo[0].y>schermo[1].y)
 {
  aus=schermo[0].y;
  schermo[0].y=schermo[1].y;
  schermo[1].y=aus;
  aus=schermo[0].x;
  schermo[0].x=schermo[1].x;
  schermo[1].x=aus;

 }
 if(schermo[1].y>schermo[2].y)
 {
  aus=schermo[1].y;
  schermo[1].y=schermo[2].y;
  schermo[2].y=aus;
  aus=schermo[1].x;
  schermo[1].x=schermo[2].x;
  schermo[2].x=aus;

 }
 if(schermo[0].y>schermo[1].y)
 {
  aus=schermo[0].y;
  schermo[0].y=schermo[1].y;
  schermo[1].y=aus;
  aus=schermo[0].x;
  schermo[0].x=schermo[1].x;
  schermo[1].x=aus;

 }
 draw_line(0,1,col,b);
 draw_line(1,2,col,&b[schermo[1].y-schermo[0].y]);
 draw_line(2,0,col,a);
 asm mov ax,0A000h
 asm mov es,ax
 asm cld
 for(i=0;i<=schermo[2].y-schermo[0].y;i++)
 {
  a1=a[i];
  b1=b[i];
  asm mov cx,a1
  asm sub cx,b1
  asm jz  next
  asm jns ok
  asm neg cx
  asm mov di,a1
  asm jmp ok2
  ok:
  asm mov di,b1
  ok2:
  asm mov al,col
  asm rep stosb
  next:
 }
}


void draw_line(int start,int end,char col,unsigned int a[])
{
 int d,dx,dy;
 int aincr,bincr,indincr,iincr;
 int x,y;
 int aus,i;
 int x1,y1,x2,y2;

 x1=schermo[start].x;
 y1=schermo[start].y;
 x2=schermo[end].x;
 y2=schermo[end].y;

 if(abs(x1-x2)>=abs(y1-y2))
 {
  if(x1>x2)
  {
   aus=x1;
   x1=x2;
   x2=aus;
   aus=y1;
   y1=y2;
   y2=aus;
  }

  if(y2>y1)
  {
   indincr=320;
   iincr=1;
   i=0;
  }
  else
  {
   indincr=-320;
   iincr=-1;
   i=y1-y2;
  }

  dx=x2-x1;
  dy=abs(y2-y1);
  d=(dy<<1)-dx;
  aincr=(dy-dx)<<1;
  bincr=dy<<1;
  x=x1;
  y=y1;

  ind=(y<<8)+(y<<6)+x;
  draw_pixel(ind,col);
  a[i]=ind;

  for(x=x1+1;x<=x2;x++)
  {
   ind++;
   if(d>=0)
   {
    ind+=indincr;
    i+=iincr;
    d+=aincr;
   }
   else d+=bincr;
   draw_pixel(ind,col);
   a[i]=ind;
  }
 }
 else
 {
  if(y1>y2)
  {
   aus=x1;
   x1=x2;
   x2=aus;
   aus=y1;
   y1=y2;
   y2=aus;
  }

  if(x2>x1) indincr=1;
  else indincr=-1;

  dy=y2-y1;
  dx=abs(x2-x1);
  d=(dx<<1)-dy;
  aincr=(dx-dy)<<1;
  bincr=dx<<1;
  y=y1;
  x=x1;

  ind=(y<<8)+(y<<6)+x;
  draw_pixel(ind,col);
  a[0]=ind;
  i=1;

  for(y=y1+1;y<=y2;y++)
  {
   ind+=320;
   if(d>=0)
   {
    ind+=indincr;
    d+=aincr;
   }
   else d+=bincr;
   draw_pixel(ind,col);
   a[i]=ind;
   i++;
  }
 }
}


void draw_pixel(int ind,char col)
{
 asm mov ax,0A000h
 asm mov es,ax
 asm mov di,ind
 asm mov al,col
 asm mov es:[di],al
}


char get_pixel(int x,int y)
{
 int ind;
 char col;

 ind=(y<<8)+(y<<6)+x;

 asm mov ax,0A000h
 asm mov es,ax
 asm mov di,ind
 asm mov al,es:[di]
 asm mov col,al

 return(col);
}