#include <math.h>
#include <dos.h>


typedef struct {
 long x,y,z;
 int xschermo,yschermo;
 char col;
} t_3d;

typedef struct {
 char ptr[3];
} t_faccia;

typedef struct {
 unsigned int ind;
 unsigned char col;
} t_lato;


void draw_face (int x1,int y1,char col1,int x2,int y2,char col2,int x3,int y3,char col3);
void draw_line(int x1,int y1,char col1,int x2,int y2,char col2,t_lato a[]);
void draw_pixel(int ind,char col);
char get_pixel(int x,int y);

t_3d punto[20],rot,spost,aus[20],normale;
t_faccia faccia[16];
int i,k,xs,ys,xmax,xmin,ymax,ymin,seno[256],coseno[256];
long nx,ny,nz,ang;
unsigned char col,a=0;
unsigned int ind;

main()
{
 _AX=0X0013;
 asm int 10h

 for(i=0;i<64;i++)
 {
  outportb(0X3C8,i);
  outportb(0X3C9,i);
  outportb(0X3C9,0);
  outportb(0X3C9,i);
 }

 punto[0].x=0;
 punto[0].y=32<<8;
 punto[0].z=0;
 punto[1].x=0;
 punto[1].y=-32<<8;
 punto[1].z=0;
 punto[10].x=0;
 punto[10].y=1<<8;
 punto[10].z=0;
 punto[11].x=0;
 punto[11].y=-1<<8;
 punto[11].z=0;

 for(i=0;i<8;i++)
 {
  punto[i+2].x=cos(i*M_PI/4)*20*256;
  punto[i+2].y=0;
  punto[i+2].z=sin(i*M_PI/4)*20*256;
  punto[i+12].x=cos(i*M_PI/4)*256;
  punto[i+12].y=0;
  punto[i+12].z=sin(i*M_PI/4)*256;
  faccia[i].ptr[0]=0;
  faccia[i].ptr[1]=(i+1)%8+2;
  faccia[i].ptr[2]=i+2;
  faccia[i+8].ptr[0]=1;
  faccia[i+8].ptr[1]=i+2;
  faccia[i+8].ptr[2]=(i+1)%8+2;
 }
 for(i=0;i<256;i++) seno[i]=sin(i*M_PI/128)*256;
 for(i=0;i<256;i++) coseno[i]=cos(i*M_PI/128)*256;
 while(!kbhit())
 {
  a++;
  spost.x=seno[a]>>2;
  spost.y=seno[(char)((a+128)<<1)]>>3;
  spost.z=seno[(char)(a+64)]>>2;
  rot.x=a;
  rot.y=a;
  rot.z=a;
  while(!(inportb(0X03DA)&0X08));
  while(inportb(0X03DA)&0X08);
  for(ind=ymin*320+xmin;ind<=ymax*320+xmin;ind+=320)
  {
   asm {
    push es
    mov  ax,0A000h
    mov  es,ax
    mov  di,ind
    xor  ax,ax
    mov  cx,xmax
    sub  cx,xmin
    shr  cx,1
    inc  cx
    rep  stosw
    pop  es
   }
  }
  xmax=ymax=0;
  xmin=319;
  ymin=199;
  for(i=0;i<20;i++)
  {
   // rotate around the x-axis
   ny=(punto[i].y*coseno[rot.x]-punto[i].z*seno[rot.x])>>8;
   nz=(punto[i].y*seno[rot.x]+punto[i].z*coseno[rot.x])>>8;
   aus[i].y=ny;
   aus[i].z=nz;

   // rotate around the y-axis
   nx=(punto[i].x*coseno[rot.y]-aus[i].z*seno[rot.y])>>8;
   nz=(punto[i].x*seno[rot.y]+aus[i].z*coseno[rot.y])>>8;
   aus[i].x=nx;
   aus[i].z=nz;

   // rotate around the z-axis
   nx=(aus[i].x*coseno[rot.z]-aus[i].y*seno[rot.z])>>8;
   ny=(aus[i].x*seno[rot.z]+aus[i].y*coseno[rot.z])>>8;
   aus[i].x=nx;
   aus[i].y=ny;
  }
  for(i=0;i<10;i++)
  {
   aus[i].z+=spost.z<<8;
   aus[i].x+=spost.x<<8;
   aus[i].y+=spost.y<<8;
   aus[i].z-=0XFF00;

   aus[i].xschermo=aus[i].x/(-aus[i].z>>8)+160;
   aus[i].yschermo=100-aus[i].y/(-aus[i].z>>8);
   aus[i].col=((-aus[i+10].x+aus[i+10].y+aus[i+10].z)>>4)+32;
   if(aus[i].xschermo>xmax) xmax=aus[i].xschermo;
   if(aus[i].xschermo<xmin) xmin=aus[i].xschermo;
   if(aus[i].yschermo>ymax) ymax=aus[i].yschermo;
   if(aus[i].yschermo<ymin) ymin=aus[i].yschermo;
  }
  for(k=0;k<16;k++)
  {
   normale.x=((aus[faccia[k].ptr[0]].y-aus[faccia[k].ptr[1]].y)*(aus[faccia[k].ptr[0]].z-aus[faccia[k].ptr[2]].z)-(aus[faccia[k].ptr[0]].z-aus[faccia[k].ptr[1]].z)*(aus[faccia[k].ptr[0]].y-aus[faccia[k].ptr[2]].y))>>16;
   normale.y=((aus[faccia[k].ptr[0]].z-aus[faccia[k].ptr[1]].z)*(aus[faccia[k].ptr[0]].x-aus[faccia[k].ptr[2]].x)-(aus[faccia[k].ptr[0]].x-aus[faccia[k].ptr[1]].x)*(aus[faccia[k].ptr[0]].z-aus[faccia[k].ptr[2]].z))>>16;
   normale.z=((aus[faccia[k].ptr[0]].x-aus[faccia[k].ptr[1]].x)*(aus[faccia[k].ptr[0]].y-aus[faccia[k].ptr[2]].y)-(aus[faccia[k].ptr[0]].y-aus[faccia[k].ptr[1]].y)*(aus[faccia[k].ptr[0]].x-aus[faccia[k].ptr[2]].x))>>16;
   ang=normale.x*aus[faccia[k].ptr[0]].x+normale.y*aus[faccia[k].ptr[0]].y+normale.z*aus[faccia[k].ptr[0]].z;
   if(ang<0) draw_face(aus[faccia[k].ptr[0]].xschermo,aus[faccia[k].ptr[0]].yschermo,aus[faccia[k].ptr[0]].col,aus[faccia[k].ptr[1]].xschermo,aus[faccia[k].ptr[1]].yschermo,aus[faccia[k].ptr[1]].col,aus[faccia[k].ptr[2]].xschermo,aus[faccia[k].ptr[2]].yschermo,aus[faccia[k].ptr[2]].col);
  }
 }
 _AX=0X0003;
 asm int 10h
 printf("Coded by  -=< Signo / DraculiA >=-\n");
 return(0);
}



void draw_face (int x1,int y1,char col1,int x2,int y2,char col2,int x3,int y3,char col3)
{
 int i,aus,aincrcol,bincrcol,deltax,dcol1,dcol,colincr,ind;
 t_lato a[100],b[100];
 char col,colincr2;

 if(y1>y2)
 {
  aus=y1;
  y1=y2;
  y2=aus;
  aus=x1;
  x1=x2;
  x2=aus;
  aus=col1;
  col1=col2;
  col2=aus;
 }
 if(y2>y3)
 {
  aus=y2;
  y2=y3;
  y3=aus;
  aus=x2;
  x2=x3;
  x3=aus;
  aus=col2;
  col2=col3;
  col3=aus;
 }
 if(y1>y2)
 {
  aus=y1;
  y1=y2;
  y2=aus;
  aus=x1;
  x1=x2;
  x2=aus;
  aus=col1;
  col1=col2;
  col2=aus;
 }
 draw_line(x1,y1,col1,x2,y2,col2,b);
 draw_line(x2,y2,col2,x3,y3,col3,&b[y2-y1]);
 draw_line(x3,y3,col3,x1,y1,col1,a);
 for(i=0;i<=y3-y1;i++)
 {
  if(a[i].ind>b[i].ind)
  {
   aus=a[i].ind;
   a[i].ind=b[i].ind;
   b[i].ind=aus;
   aus=a[i].col;
   a[i].col=b[i].col;
   b[i].col=aus;
  }
  if(b[i].ind==a[i].ind) draw_pixel(a[i].ind,a[i].col);
  else
  {
   deltax=b[i].ind-a[i].ind;

   if(b[i].col>a[i].col)
   {
    colincr=1;
    _AX=b[i].col-a[i].col;
    _DX=deltax;
    asm div dl
    colincr2=_AL;
    dcol1=_AH;
    /*dcol1=b[i].col-a[i].col;
    colincr2=0;
    while(dcol1>deltax)
    {
     dcol1-=deltax;
     colincr2++;
    } */
   }
   else
   {
    colincr=-1;
    _AX=a[i].col-b[i].col;
    _DX=deltax;
    asm div dl
    colincr2=-_AL;
    dcol1=_AH;
    /*dcol1=a[i].col-b[i].col;
    colincr2=0;
    while(dcol1>deltax)
    {
     dcol1-=deltax;
     colincr2--;
    }*/
   }
   dcol=(dcol1<<1)-deltax;
   aincrcol=(dcol1-deltax)<<1;
   bincrcol=dcol1<<1;
   col=a[i].col;
   ind=a[i].ind;
   draw_pixel(ind,col);
   asm mov ax,0A000h
   asm mov es,ax
   asm mov di,ind
   asm inc di
   asm mov dx,dcol
   asm mov cx,deltax
   asm mov ax,colincr
   asm mov ah,al
   asm mov al,col
//   asm mov bx,aincrcol
//   asm mov dh,bl
//   asm mov bx,bincrcol
   asm mov bh,colincr2
   ciclo:
    asm or  dx,dx
    asm js  lab1
    asm add al,ah
    asm add dx,aincrcol
    asm jmp lab2
    lab1:
    asm add dx,bincrcol
    lab2:
    asm add al,bh
    asm mov es:[di],al
    asm inc di
    asm dec cl
   asm jnz ciclo
  }
 }
}


void draw_line(int x1,int y1,char col1,int x2,int y2,char col2,t_lato a[])
{
 int d,dx,dy,dcol,dcol1;
 int aincr,bincr,indincr,iincr,colincr;
 int aincrcol,bincrcol;
 int x,y;
 int aus,i;
 char col;
 signed char colincr2;
 unsigned int ind;

 if(x1==x2 && y1==y2)
 {
  ind=(y1<<8)+(y1<<6)+x1;
  col=(col1+col2)>>1;
  //draw_pixel(ind,col);
  a[0].ind=ind;
  a[0].col=col;
  return;
 }
 if(abs(x1-x2)>=abs(y1-y2))
 {
  if(x1>x2)
  {
   aus=x1;
   x1=x2;
   x2=aus;
   aus=y1;
   y1=y2;
   y2=aus;
   aus=col1;
   col1=col2;
   col2=aus;
  }

  if(y2>y1)
  {
   indincr=320;
   iincr=1;
   i=0;
  }
  else
  {
   indincr=-320;
   iincr=-1;
   i=y1-y2;
  }

  dx=x2-x1;

  if(col2>col1)
  {
   colincr=1;
   _AX=col2-col1;
   _DX=dx;
   asm div dl
   colincr2=_AL;
   dcol1=_AH;
   //dcol1=col2-col1;
   //colincr2=0;
   //while(dcol1>dx)
   //{
   // dcol1-=dx;
   // colincr2++;
   //}
  }
  else
  {
   colincr=-1;
   _AX=col1-col2;
   _DX=dx;
   asm div dl
   colincr2=-_AL;
   dcol1=_AH;
   //dcol1=col1-col2;
   //colincr2=0;
   //while(dcol1>dx)
   //{
   // dcol1-=dx;
   // colincr2--;
   //}
  }

  dy=abs(y2-y1);
  d=(dy<<1)-dx;
  dcol=(dcol1<<1)-dx;
  aincr=(dy-dx)<<1;
  aincrcol=(dcol1-dx)<<1;
  bincr=dy<<1;
  bincrcol=dcol1<<1;
  x=x1;
  y=y1;
  col=col1;

  ind=(y<<8)+(y<<6)+x;
  //draw_pixel(ind,col);
  a[i].ind=ind;
  a[i].col=col;

  for(x=x1+1;x<=x2;x++)
  {
   ind++;
   if(d>=0)
   {
    ind+=indincr;
    i+=iincr;
    d+=aincr;
   }
   else d+=bincr;
   if(dcol>=0)
   {
    col+=colincr;
    dcol+=aincrcol;
   }
   else dcol+=bincrcol;

   col+=colincr2;
   //draw_pixel(ind,col);
   a[i].ind=ind;
   a[i].col=col;
  }
 }
 else
 {
  if(y1>y2)
  {
   aus=x1;
   x1=x2;
   x2=aus;
   aus=y1;
   y1=y2;
   y2=aus;
   aus=col1;
   col1=col2;
   col2=aus;
  }

  if(x2>x1) indincr=1;
  else indincr=-1;

  dy=y2-y1;

  if(col2>col1)
  {
   colincr=1;
   _AX=col2-col1;
   _DX=dy;
   asm div dl
   colincr2=_AL;
   dcol1=_AH;
   //dcol1=col2-col1;
   //colincr2=0;
   //while(dcol1>dy)
   //{
   // dcol1-=dy;
   // colincr2++;
   //}
  }
  else
  {
   colincr=-1;
   _AX=col1-col2;
   _DX=dy;
   asm div dl
   colincr2=-_AL;
   dcol1=_AH;
   //dcol1=col2-col1;
   //colincr2=0;
   //while(dcol1>dy)
   //{
   // dcol1-=dy;
   // colincr2--;
   //}
  }

  dx=abs(x2-x1);
  d=(dx<<1)-dy;
  dcol=(dcol1<<1)-dy;
  aincr=(dx-dy)<<1;
  aincrcol=(dcol1-dy)<<1;
  bincr=dx<<1;
  bincrcol=dcol1<<1;
  y=y1;
  x=x1;
  col=col1;

  ind=(y<<8)+(y<<6)+x;
  //draw_pixel(ind,col);
  a[0].ind=ind;
  a[0].col=col;
  i=1;

  for(y=y1+1;y<=y2;y++)
  {
   ind+=320;
   if(d>=0)
   {
    ind+=indincr;
    d+=aincr;
   }
   else d+=bincr;
   if(dcol>=0)
   {
    col+=colincr;
    dcol+=aincrcol;
   }
   else dcol+=bincrcol;
   col+=colincr2;
   //draw_pixel(ind,col);
   a[i].ind=ind;
   a[i].col=col;
   i++;
  }
 }
}


void draw_pixel(int ind,char col)
{
 asm mov ax,0A000h
 asm mov es,ax
 asm mov di,ind
 asm mov al,col
 asm mov es:[di],al
}


char get_pixel(int x,int y)
{
 int ind;
 char col;

 ind=(y<<8)+(y<<6)+x;

 asm mov ax,0A000h
 asm mov es,ax
 asm mov di,ind
 asm mov al,es:[di]
 asm mov col,al

 return(col);
}